Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	The OpenSSL toolkit
Name:      	openssl
Version:   	0.9.8o
Release:   	1
BuildArch:	i686
License: 	OpenSSL
URL:		http://www.openssl.org/
Group:     	System/Libraries          
Source0: 	%{name}-%{version}.tar.gz
Source1: 	hobble-openssl
Source2: 	Makefile.certificate
Source3: 	ca-bundle.crt
Source4: 	https://rhn.redhat.com/help/RHNS-CA-CERT
Source5:	https://rhn.redhat.com/help/RHNS-CA-CERT.asc
Source6: 	make-dummy-cert
Source8: 	openssl-thread-test.c
Source9: 	opensslconf-new.h
Source10: 	opensslconf-new-warning.h
Patch1: 	openssl-0.9.8a-defaults.patch
Patch2: 	openssl-0.9.8a-link-krb5.patch
Patch4: 	openssl-0.9.8l-enginesdir.patch
Patch5: 	openssl-0.9.8a-no-rpath.patch
Patch33:        openssl-0.9.8m-ca-dir.patch

BuildRoot: 	%{_tmppath}/%{name}-buildroot
BuildRequires: 	mktemp, sed, diffutils
Requires: 	mktemp

%define		soversion 6
%define 	thread_test_threads %{?threads:%{threads}}%{!?threads:1}

#Automatically resolved build dependencies
BuildRequires: e2fsprogs-devel
BuildRequires: glibc-devel
BuildRequires: krb5-devel
BuildRequires: perl
BuildRequires: pkg-config
BuildRequires: zlib-devel

%description
The OpenSSL toolkit provides support for secure communications between
machines. OpenSSL includes a certificate management tool and shared
libraries which provide various cryptographic algorithms and
protocols.

%package	devel
Summary: 	Files for development of applications which will use OpenSSL
Group: 		Development/Libraries
Requires: 	%{name} = %{version}-%{release}, krb5-devel, zlib-devel
Requires: 	pkgconfig

%description	devel
OpenSSL is a toolkit for supporting cryptography. The openssl-devel
package contains static libraries and include files needed to develop
applications which support various cryptographic algorithms and
protocols.

%package	perl
Summary: 	Perl scripts provided with OpenSSL
Group: 		System/Libraries
Requires: 	perl
Requires: 	%{name} = %{version}-%{release}

%description	perl
OpenSSL is a toolkit for supporting cryptography. The openssl-perl
package provides Perl scripts for converting certificates and keys
from other formats to the formats used by the OpenSSL toolkit.

%post
ldconfig

%postun
ldconfig

%prep
%setup -q -n %{name}-%{version}
cp %{SOURCE1} $RPM_BUILD_DIR/%{name}-%{version}
./hobble-openssl > /dev/null

%patch1 -p1 -b .defaults
# Fix link line for libssl (bug #111154).
%patch2 -p1 -b .krb5
#%patch4 -p1 -b .enginesdir
%patch5 -p1 -b .no-rpath


# Modify the various perl scripts to reference perl in the right location.
perl util/perlpath.pl `dirname %{__perl}`

# Generate a table with the compile settings for my perusal.
touch Makefile
make TABLE PERL=%{__perl}

%build
# Figure out which flags we want to use.
# default
sslarch=%{_os}-%{_arch}
%ifarch %ix86
sslarch=linux-elf
if ! echo %{_target} | grep -q i686 ; then
	sslflags="no-asm 386"
fi
%endif

# Configure the build tree.  Override OpenSSL defaults with known-good defaults
# usable on all platforms.  The Configure script already knows to use -fPIC and
# RPM_OPT_FLAGS, so we can skip specifiying them here.
./Configure \
	--prefix=%{_prefix} --openssldir=%{_sysconfdir}/pki/tls ${sslflags} \
	zlib no-idea no-mdc2 no-rc5 no-ec no-ecdh no-ecdsa shared enable-tlsext \
	--with-krb5-flavor=MIT ${sslarch}

# Add -Wa,--noexecstack here so that libcrypto's assembler modules will be
# marked as not requiring an executable stack.
RPM_OPT_FLAGS="$RPM_OPT_FLAGS -Wa,--noexecstack"
make depend
make all build-shared

# Generate hashes for the included certs.
make rehash build-shared

# Verify that what was compiled actually works.
LD_LIBRARY_PATH=`pwd`${LD_LIBRARY_PATH:+:${LD_LIBRARY_PATH}}
export LD_LIBRARY_PATH
make -C test apps tests
%{__cc} -o openssl-thread-test \
	`krb5-config --cflags` \
	-I./include \
	$RPM_OPT_FLAGS \
	%{SOURCE8} \
	-L. \
	-lssl -lcrypto \
	`krb5-config --libs` \
	-lpthread -lz -ldl
./openssl-thread-test --threads %{thread_test_threads}

# Patch33 must be patched after tests otherwise they will fail
patch -p1 -b -z .ca-dir < %{PATCH33}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
# Install OpenSSL.
install -d $RPM_BUILD_ROOT/{%{_lib},%{_bindir},%{_includedir},%{_libdir},%{_mandir},%{_libdir}/openssl}
make INSTALL_PREFIX=$RPM_BUILD_ROOT install build-shared
# OpenSSL install doesn't use correct _libdir
#mv $RPM_BUILD_ROOT/usr/lib/lib*.so.%{soversion} $RPM_BUILD_ROOT/%{_lib}/
mv $RPM_BUILD_ROOT/usr/lib/engines $RPM_BUILD_ROOT/%{_libdir}/openssl
mv $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/man/* $RPM_BUILD_ROOT%{_mandir}/
rmdir $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/man
mv $RPM_BUILD_ROOT/usr/lib/* $RPM_BUILD_ROOT%{_libdir}/ || :
#rename so.%{soversion} so.%{version} $RPM_BUILD_ROOT/%{_lib}/*.so.%{soversion}
#for lib in $RPM_BUILD_ROOT/%{_lib}/*.so.%{version} ; do
#	chmod 755 ${lib}
#	ln -s -f ../../%{_lib}/`basename ${lib}` $RPM_BUILD_ROOT%{_libdir}/`basename ${lib} .%{version}`
#	ln -s -f `basename ${lib}` $RPM_BUILD_ROOT/%{_lib}/`basename ${lib} .%{version}`.%{soversion}
#	rm -f $RPM_BUILD_ROOT%{_libdir}/`basename ${lib} .%{version}`.%{soversion}
#done

# Install a makefile for generating keys and self-signed certs, and a script
# for generating them on the fly.
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs
install -m644 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs/Makefile
install -m755 %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs/make-dummy-cert

# Make sure we actually include the headers we built against.
for header in $RPM_BUILD_ROOT%{_includedir}/openssl/* ; do
	if [ -f ${header} -a -f include/openssl/$(basename ${header}) ] ; then
		install -m644 include/openssl/`basename ${header}` ${header}
	fi
done

# Rename man pages so that they don't conflict with other system man pages.
pushd $RPM_BUILD_ROOT%{_mandir}
for manpage in man*/* ; do
	if [ -L ${manpage} ]; then
		TARGET=`ls -l ${manpage} | awk '{ print $NF }'`
		ln -snf ${TARGET}ssl ${manpage}ssl
		rm -f ${manpage}
	else
		mv ${manpage} ${manpage}ssl
	fi
done
for conflict in passwd rand ; do
	rename ${conflict} ssl${conflict} man*/${conflict}*
done
popd

# Pick a CA script.
pushd  $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/misc
mv CA.sh CA
popd

mkdir -m700 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA
mkdir -m700 $RPM_BUILD_ROOT%{_sysconfdir}/pki/CA/private

# Install root CA stuffs.
cat << EOF > RHNS-blurb.txt
#
#  RHNS CA certificate.  Appended to the ca-bundle at package build-time.
#
EOF
cat %{SOURCE3} RHNS-blurb.txt %{SOURCE4} > ca-bundle.crt
install -m644 ca-bundle.crt $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs/
ln -s certs/ca-bundle.crt $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/cert.pem
# Reference timestamps to prevent multilib conflicts
touch -r %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/certs/ca-bundle.crt
touch -r %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/pki/tls/openssl.cnf

# Fix libdir.
pushd $RPM_BUILD_ROOT/%{_libdir}/pkgconfig
for i in *.pc ; do
	sed 's,^libdir=${exec_prefix}/lib,libdir=${exec_prefix}/%{_lib},g' \
	    $i >$i.tmp && \
	cat $i.tmp >$i && \
	rm -f $i.tmp
done
popd

# Determine which arch opensslconf.h is going to try to #include.
basearch=%{_arch}
%ifarch %{ix86}
basearch=i386
%endif

# Do an opensslconf.h switcheroo to avoid file conflicts on systems where you
# can have both a 32- and 64-bit version of the library, and they each need
# their own correct-but-different versions of opensslconf.h to be usable.
install -m644 %{SOURCE10} \
   $RPM_BUILD_ROOT/%{_prefix}/include/openssl/opensslconf-${basearch}.h
cat $RPM_BUILD_ROOT/%{_prefix}/include/openssl/opensslconf.h >> \
   $RPM_BUILD_ROOT/%{_prefix}/include/openssl/opensslconf-${basearch}.h
install -m644 %{SOURCE9} \
   $RPM_BUILD_ROOT/%{_prefix}/include/openssl/opensslconf.h

# Remove fips fingerprint script 
rm -rf $RPM_BUILD_ROOT/%{_bindir}/openssl_fips_fingerprint

%files 
%defattr(-,root,root)
%doc FAQ LICENSE CHANGES NEWS INSTALL README
%doc doc/README doc/c-indentation.el doc/openssl.txt
%doc doc/openssl_button.html doc/openssl_button.gif
%doc doc/ssleay.txt
%dir %{_sysconfdir}/pki/tls
%dir %{_sysconfdir}/pki/tls/certs
%{_sysconfdir}/pki/tls/certs/make-dummy-cert
%{_sysconfdir}/pki/tls/certs/Makefile
%{_sysconfdir}/pki/tls/cert.pem
%dir %{_sysconfdir}/pki/tls/misc
%{_sysconfdir}/pki/tls/misc/CA
%dir %{_sysconfdir}/pki/CA
%dir %{_sysconfdir}/pki/CA/private
%{_sysconfdir}/pki/tls/misc/c_*
%{_sysconfdir}/pki/tls/private

%config(noreplace) %{_sysconfdir}/pki/tls/openssl.cnf
%config(noreplace) %{_sysconfdir}/pki/tls/certs/ca-bundle.crt

%attr(0755,root,root) %{_bindir}/openssl
%attr(0755,root,root) %{_libdir}/libcrypto.so.*
%attr(0755,root,root) %{_libdir}/libssl.so.*
%attr(0755,root,root) %{_libdir}/openssl
%attr(0644,root,root) %{_mandir}/man1*/[ABD-Zabcd-z]*
%attr(0644,root,root) %{_mandir}/man5*/*
%attr(0644,root,root) %{_mandir}/man7*/*

%files devel
%defattr(-,root,root)
%{_prefix}/include/openssl
%attr(0755,root,root) %{_libdir}/libcrypto.a
%attr(0755,root,root) %{_libdir}/libssl.a
%attr(0755,root,root) %{_libdir}/libcrypto.so
%attr(0755,root,root) %{_libdir}/libssl.so
%attr(0644,root,root) %{_mandir}/man3*/*
%attr(0644,root,root) %{_libdir}/pkgconfig/libcrypto.pc
%attr(0644,root,root) %{_libdir}/pkgconfig/libssl.pc
%attr(0644,root,root) %{_libdir}/pkgconfig/openssl.pc

%files perl
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/c_rehash
%attr(0644,root,root) %{_mandir}/man1*/*.pl*
%dir %{_sysconfdir}/pki/tls/misc
%{_sysconfdir}/pki/tls/misc/*.pl

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Jun 03 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8o-1
- Version Update
* Sun Mar 28 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8n-1
- Version Update
* Thu Mar 04 2010 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8m-1
- Version Update
* Thu Nov 12 2009 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8l-1
- Version Update
* Sun Mar 29 2009 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8k-1
- Version Update
* Sat Jan 10 2009 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8j-1
- Version Update
* Mon Sep 15 2008 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8i-1
- Version Update
* Tue Jul 29 2008 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8h-1
- Version Update
- enabled tls extension for wpa_supplicant
* Tue Mar 25 2008 Christian Wasem <wasem@ccux-linux.de> 0.9.8g-3
- rebuild, changed perl package group to System/Libraries,
- correcting copy&paste from fedora.spec!!! We Are NOT Fedora!!!
* Wed Jan 16 2008 Christian Metzen <metzench@ccux-linux.de> 0.9.8g-2
- rebuild for changed packaging scheme, moving files to better locations
* Fri Oct 19 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8g-1
- Version Update
* Sat Sep 29 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8e-2
- added gcc 4.2 patch
- added md4 patch (fixes https:// crash in konqueror)
* Wed Sep 05 2007 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8e-1
- Version Update
* Fri Sep 29 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8d-1
- Version Update
* Wed Sep 06 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8c-1
- Version Update 
* Sun Jul 09 2006 Karsten Brockmann <arcam@ccux-linux.de> 0.9.8b-1
- Version Update to 0.9.8b
* Wed Dec 14 2005 Stefan Gottwald <gotti@ccux-linux.de> 0.9.8a-2
- Added Patch for WPA
* Wed Oct 12 2005 Christian Metzen <metzench@ccux-linux.de> 0.9.8a-1
- Version update, removed compat files
* Sat Jul 09 2005 Christian Metzen <metzench@ccux-linux.de> 0.9.8-2
- Tweaked specfile, added missing Tags, moved static files to devel package
* Wed Jul 06 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 0.9.8-1
- Version Update to 0.9.8
* Mon Dec 27 2004 Christian Metzen <metzench@ccux-linux.de> 0.9.7d-2
- Initial Release
